const connectionPool = require("../../../config/db");

module.exports = {
    fetchLovHead : (callBack) =>{
        connectionPool.query(`SELECT id, lovHeader, description from XXCRM_LOV_HEAD`,
        [],(error, results, fields)=>{
            if(error){
                return callBack(error);
            }
            return callBack(null, results);

        });

    },
    fetchLovSetup : (id, callBack) =>{
        
        connectionPool.query(`SELECT a.id as HeaderId, b.id as value_id, b.lovValues as value, b.description, b.status
        FROM XXCRM_LOV_HEAD a, XXCRM_LOV_SETUP b
        where a.id = b.lovheadID 
        and a.id = ${id}`,[],(error, results, fields)=>{
            if(error){
                return callBack(error);
            }
            return callBack(null, results);
        })
    },
    fetchActiveLov : (id, callBack) =>{
        
        connectionPool.query(`SELECT a.id as HeaderId, b.id as value_id, b.lovValues as value, b.description, b.status
        FROM XXCRM_LOV_HEAD a, XXCRM_LOV_SETUP b
        where a.id = b.lovheadID and b.status='Active'
        and a.id = ${id}`,[],(error, results, fields)=>{
            if(error){
                return callBack(error);
            }
            return callBack(null, results);
        })
    },
    createSetup : (data, callBack) =>{
        var id = data.id;
        var newField = '';
        for(const result of data.lovSetUp){
             newField = result.newField;
            var statusValue;
            if(result.status == true){
                statusValue = 'Active';
            }
            else{
                statusValue = 'Inactive';
            }
            if(newField == true){
                connectionPool.query(`INSERT INTO XXCRM_LOV_SETUP(lovheadID, lovValues, 
                    description, status, insert_at) VALUES(?,?,?,?,?)`,
                    [id, result.value, result.description, statusValue, new Date()],
            (error, results, fields) =>{
                if(error){
                    return callBack(error);
                }
            });
            }
            else{
                connectionPool.query(`UPDATE XXCRM_LOV_SETUP SET lovValues =?, description =?, status =? where lovheadID =? and id=?`,
                [result.value, result.description, statusValue,id,result.value_id],
                (error, results, fields)=>{
                    if(error){
                        return callBack(error);
                    }
                })
          
            }

    }
    return callBack(null, results);

    }
}
