const connectionPool = require("../../config/db");

module.exports={
    generateCode:(callBack)=>{
        connectionPool.query(`select contactCode from XXCRM_CONTACTS_HEADER order by id desc limit 1`,[],
        (error, results, fields) =>{
           var numRows = results.length;
           
            if(error){
                return callBack(error);
            }

results['numRows']=numRows;
            return callBack(null, results);
        })
    },
createContact:(data,callBack)=>{
var partyName, partyId;
   connectionPool.query(`select partyName,id from XXCRM_PARTY where partyCode = ? order 
   by id desc limit 1`,[data.partyCode],
   (error, results, fields) =>{   
    partyName = results[0]['partyName'];
    partyId = results[0]['id'];
       connectionPool.query(`INSERT INTO XXCRM_CONTACTS_HEADER(contactCode,
    partyName, partyCode, partyId, leadId) VALUES(?,?,
        ?,?,?)`,[data.contactCode,partyName,data.partyCode,partyId,data.leadID],
        (error, results, fields) =>{
            
            var lastInsertedId = results.insertId;
            for(const result of data.lineData){
                // console.log(result.contactName);
connectionPool.query(`INSERT INTO XXCRM_CONTACTS_LINE(contactId, PartyId,
 contactName, contactTitle, contactEmail, knownAs, kaladiFunction, mobile, linkedInProfile) VALUES
 (?,?,?,?,?,?,?,?,?)`,
 [lastInsertedId,partyId,result.contactName,result.contactTitle,
    result.contactEmail,result.knownAs,
    result.contactFunction,result.contactMobile,result.linkedInProfile],
 (error, results, fields) =>{  
    if(error){
        return callBack(error);
    } 
 })
 }
            return callBack(null, results);
        });
   })
},
fetchAllContacts:(data,offset,pagesize, callBack)=>{
    var contactFilter, partyFilter;
    if(data.contactCode == ''){
        contactFilter = '';
    }
    else{
        contactFilter = 'and contactCode = ("'+data.contactCode+'")';
    }
    if(data.partyCode == ''){
        partyFilter = '';
    }
    else{
        partyFilter = 'and partyCode = ("'+data.partyCode+'")';
    }
    connectionPool.query(`SELECT id, contactCode, partyName, partyCode, 
    partyId, leadId
    FROM XXCRM_CONTACTS_HEADER WHERE  1=1 ${contactFilter} ${partyFilter} LIMIT ${offset},${pagesize}`,[],
    (error, results, fields) =>{
if(error){
    return callBack(error);
}
return callBack(null, results);
    })

},
fetchContactById:(data, callBack)=>{
    var id = data.id;
connectionPool.query(`SELECT id, contactCode, partyName, partyCode, partyId, leadId 
FROM XXCRM_CONTACTS_HEADER where id = ${id}`,[],
(error, results, fields) =>{
    connectionPool.query(`SELECT id as lineId, contactName, contactTitle, contactEmail, knownAs, kaladiFunction, mobile,
    linkedInProfile FROM XXCRM_CONTACTS_LINE where contactId = ${id}`,
    [],
    (error,lineresults, fields)=>{
        results[0]['lineData'] = lineresults;
        return callBack(null, results);
    })

})

},
updateContact:(data, callBack)=>{

    var partyName, partyId;
    var headerId = data.id;
   connectionPool.query(`select partyName,id from XXCRM_PARTY where partyCode = ? order 
   by id desc limit 1`,[data.partyCode],
   (error, results, fields) =>{   
    partyName = results[0]['partyName'];
    partyId = results[0]['id'];

    connectionPool.query(`UPDATE XXCRM_CONTACTS_HEADER SET partyCode = ?,partyName = ?,partyId = ?,
    leadId = ? where id = ?`,[data.partyCode, partyName,partyId,data.leadID, data.id],
    (error, results, field)=>{

        for(const result of data.lineData){
            var newField = result.newField;
            if(newField == true){

                connectionPool.query(`INSERT INTO XXCRM_CONTACTS_LINE(contactId, PartyId,
                    contactName, contactTitle, contactEmail, knownAs, kaladiFunction, mobile, linkedInProfile) VALUES
                    (?,?,?,?,?,?,?,?,?)`,
                    [headerId,partyId,result.contactName,result.contactTitle,
                    result.contactEmail,result.knownAs,
                    result.contactFunction,result.contactMobile,result.linkedInProfile],
                    (error, results, fields) =>{  
                    if(error){
                        return callBack(error);
                    } 
                    })
                    

            }
            else{
                connectionPool.query(`UPDATE XXCRM_CONTACTS_LINE
                SET PartyId = ?,
                    contactName =?, contactTitle=?, contactEmail=?, knownAs=?, kaladiFunction=?,
                     mobile=?, linkedInProfile=? where contactId = ? and id = ?`,
                    [partyId,result.contactName,result.contactTitle,
                    result.contactEmail,result.knownAs,
                    result.contactFunction,result.contactMobile,result.linkedInProfile,headerId,result.lineId],
                    (error, results, fields) =>{  
                    if(error){
                        return callBack(error);
                    } 
                    })
            }
}

return callBack(null, results);

    })

})

}
}