const connectionPool = require("../../config/db");

module.exports = {
    leadStat : (country, business, status, offerings,
        c1,c2,c3,b1,b2,b3,s1,s2,s3,l1,l2,l3,callBack)=>{
        connectionPool.query(`SELECT count(distinct(a.partyCode)) as total_leads, 
        (SELECT sum(c.value) as estimated_opps_value
        FROM XXCRM_OPPS a, XXCRM_ESTIMATION_HEADER b, XXCRM_ESTIMATION_LINE c
        WHERE
        b.oppsId = a.OppID and
        a.status = 'Opportunity' 
        and b.id = c.estimateId ${c1} ${b1} ${s1} ${l1}) as opportunity_values,
        (select count(distinct(partyCode)) FROM XXCRM_LEADS
        where month(initiationDate) = month(curdate())-1 ${country} ${business} ${status} ${offerings}) 
        as last_month_leads,(select count(distinct(partyCode)) 
        FROM XXCRM_LEADS where month(initiationDate) = month(curdate())) as current_month_leads,
count(distinct(b.partyCode)) as total_opps,(SELECT sum(c.value) as 
estimated_deal_value FROM XXCRM_OPPS a, XXCRM_ESTIMATION_HEADER b, XXCRM_ESTIMATION_LINE c
WHERE
b.oppsId = a.OppID and
a.status = 'Deal'
and b.id = c.estimateId  ${c1} ${b1} ${s1} ${l1}) as deals_values,
 (select count(distinct(partyCode)) FROM XXCRM_OPPS
        where month(initiationDate) = month(curdate())-1 ${country} ${business} ${status} ${offerings}) 
        as last_month_opps,(select count(distinct(partyCode)) 
        FROM XXCRM_OPPS where month(initiationDate) = month(curdate())) as current_month_opps,
count(distinct(c.partyCode)) as total_deals, (select count(distinct(partyCode)) FROM XXCRM_DEALS
        where month(initiationDate) = month(curdate())-1 ${country} ${business} ${status} ${offerings} ) as 
        last_month_deals,(select count(distinct(partyCode)) 
        FROM XXCRM_DEALS where month(initiationDate) = month(curdate())) as current_month_deals
FROM XXCRM_LEADS a, XXCRM_OPPS b, XXCRM_DEALS c 
where 1=1 ${c1} ${b1} ${s1} ${l1} ${c2} ${b2} ${s2} ${l2} ${c3} ${b3} ${s3} ${l3}`,
        [], (error, results, fields)=>{
            if(error){
                return callBack(error);
            }
            return callBack(null, results);

        });



    },
    sendFinancialYear : (callBack)=>{
        connectionPool.query(`SELECT 
        DATE_FORMAT(m1, '%b') as months_inc
        FROM
        (
        SELECT 
        ((SELECT financial_year_start FROM XXCRM_SETTINGS) - INTERVAL 
        DAYOFMONTH((SELECT financial_year_start FROM XXCRM_SETTINGS))-1 DAY) 
        +INTERVAL m MONTH as m1
        FROM
        (
        SELECT @rownum:=@rownum+1 as m FROM
        (SELECT 1 union SELECT 2 union SELECT 3 union SELECT 4) t1,
        (SELECT 1 union SELECT 2 union SELECT 3 union SELECT 4) t2,
        (SELECT 1 union SELECT 2 union SELECT 3 union SELECT 4) t3,
        (SELECT 1 union SELECT 2 union SELECT 3 union SELECT 4) t4,
        (SELECT @rownum:=-1) t0
        ) d1
        ) d2 
        where m1<=(SELECT financial_year_end FROM XXCRM_SETTINGS)
        order by m1`, [],(error, results, fields) =>{
            if(error){
                return callBack(error);
            }
            return callBack(null, results);
        })

    },
    leadsCount:(con,business,status,offerings,callBack)=>{

        // console.log(con);
// var country = con.replace(/"/g,'');
     
   connectionPool.query(`SELECT a.month as months_inc,if(f.leadsCount is NULL,0,f.leadsCount) as 
   leadsCount from XXCRM_MONTHS_MASTER a LEFT  JOIN 
    (SELECT YEAR(initiationDate) AS y, MONTH(initiationDate) AS m, 
   COUNT(DISTINCT LeadID) as leadsCount, MONTHNAME(initiationDate) as month, 
   DATE_FORMAT(initiationDate, '%b') as months_inc
   FROM XXCRM_LEADS where 1=1 ${con} ${business} ${status} ${offerings}  GROUP BY y, m) f on a.month = f.months_inc
   order by a.ordering asc`,[],(error, results, fields)=>{
        if(error){
            return callBack(error);
        }
        return callBack(null, results);
    });


    },
    oppsCount:(con,business,status,offerings,callBack)=>{
        connectionPool.query(`SELECT a.month as months_inc,if(f.oppsCount is NULL,0,f.oppsCount) as 
        oppsCount from XXCRM_MONTHS_MASTER a LEFT  JOIN 
        (SELECT YEAR(initiationDate) AS y, MONTH(initiationDate) AS m, 
       COUNT(DISTINCT OppID) as oppsCount, MONTHNAME(initiationDate) as month, 
       DATE_FORMAT(initiationDate, '%b') as months_inc
       FROM XXCRM_OPPS where 1=1 ${con} ${business} ${status} ${offerings}  GROUP BY y, m) f on a.month = f.months_inc
       order by a.ordering asc`,[],(error,results, fields)=>{
            if(error){
                return callBack(error);
            }
            return callBack(null, results);
        })
    },
    dealsCount:(con,business,status,offerings,callBack)=>{
        connectionPool.query(`SELECT a.month as months_inc,if(f.dealsCount is NULL,0,f.dealsCount) as 
        dealsCount from XXCRM_MONTHS_MASTER a LEFT  JOIN 
    (SELECT YEAR(initiationDate) AS y, MONTH(initiationDate) AS m, 
   COUNT(DISTINCT DealID) as dealsCount, MONTHNAME(initiationDate) as month, 
   DATE_FORMAT(initiationDate, '%b') as months_inc
   FROM XXCRM_DEALS where 1=1 ${con} ${business} ${status} ${offerings}  GROUP BY y, m) f on a.month = f.months_inc
   order by a.ordering asc`,[],(error, results, fields)=>{
            if(error){
                return callBack(error);
            }
            return callBack(null, results);
        })
            },

    oppsValue:(con,business,status,offerings,callBack)=>{
        connectionPool.query(`SELECT a.month as months_inc,if(f.estimated_opps_value is NULL,0,f.estimated_opps_value)
         as estimated_opps_value from
        XXCRM_MONTHS_MASTER a LEFT JOIN 
        ( SELECT sum(c.value) as estimated_opps_value, DATE_FORMAT(b.estimationDate , "%b") as months_inc
                FROM XXCRM_OPPS a, XXCRM_ESTIMATION_HEADER b, XXCRM_ESTIMATION_LINE c
                WHERE
                b.oppsId = a.OppID and
                a.status = 'Opportunity'
                and b.id = c.estimateId ${con} ${business} ${status} ${offerings} group by month(b.estimationDate))f
                 on a.month = f.months_inc
                order by a.ordering asc`,[],(error, results, fields)=>{
            if(error){
                return callBack(error);
            }
            return callBack(null, results);
        })
    },
    dealsValue:(con,business,status,offerings,callBack)=>{
        connectionPool.query(`SELECT a.month as months_inc, if(f.estimated_deals_value is NULL,0,f.estimated_deals_value) as estimated_deals_value from
        XXCRM_MONTHS_MASTER a LEFT JOIN 
        ( SELECT sum(c.value) as estimated_deals_value, DATE_FORMAT(b.estimationDate , "%b") as months_inc
                FROM XXCRM_OPPS a, XXCRM_ESTIMATION_HEADER b, XXCRM_ESTIMATION_LINE c
                WHERE
                b.oppsId = a.OppID and
                a.status = 'Deal'
                and b.id = c.estimateId ${con} ${business}  ${status} ${offerings} group by 
                month(b.estimationDate))f on a.month = f.months_inc
                order by a.ordering asc`,[],(error, results, fields)=>{
            if(error){
                return callBack(error);
            }
            return callBack(null, results);
        })
    },
    leadsOppsList:(con,business,status,offerings,callBack)=>{
       
        connectionPool.query(`SELECT  @s:=@s+1 sno,a.LeadID, a.partyName, a.Location as location, a.country,'' as domain,
         a.business, a.likelyOfferings,
        b.partyName as opportunity,a.partyType as type,
        sum(d.value) as value,a.initiationDate, a.SPOC as spoc, a.status
        FROM XXCRM_LEADS a, XXCRM_OPPS b, XXCRM_ESTIMATION_HEADER c, XXCRM_ESTIMATION_LINE d,
        (SELECT @s:= 0) AS s
        where a.LeadID = b.LeadID
        and b.OppID = c.oppsId
        and c.id = d.estimateId  ${con} ${business}  ${status} ${offerings}
        group by d.estimateId`,[],(error, results, fields)=>{
            if(error){
                return callBack(error);
            }
            return callBack(null, results);
        })
    },
    oppsDealsList:(con,business,status,offerings,callBack)=>{
        connectionPool.query(`SELECT @s:=@s+1 sno,a.OppID, a.partyName, a.Location as location, a.country,'' as domain, 
        a.business, a.likelyOfferings,
        b.partyName as opportunity,a.partyType as type,
        sum(d.value)  as value ,a.initiationDate, a.SPOC as spoc, a.status
        FROM XXCRM_OPPS a, XXCRM_DEALS b, XXCRM_ESTIMATION_HEADER c, XXCRM_ESTIMATION_LINE d,
(SELECT @s:= 0) AS s
        where a.OppID = b.OppID
        and a.OppID = c.oppsId
        and c.id = d.estimateId ${con} ${business}  ${status} ${offerings}
        group by d.estimateId`,[],(error, results, fields)=>{
            if(error){
                return callBack(error);
            }
            return callBack(null, results);
        })
    }

};