const {fetchEstLoV,fetchLeadLoV,fetchOppsLoV,fetchPartyLoV,fetchPartyDetails,
    generateEstCode,addEstimation,fetchAllEstimation,fetchEstById,updateEst} = require("./est.controller");


const router = require('express').Router();
const { checkToken } = require("../../auth/jwt_validation");
const { create } = require("domain");

router.post("/fetchEstLoV", checkToken, fetchEstLoV);
router.post("/fetchLeadLoV", checkToken, fetchLeadLoV);
router.post("/fetchOppsLoV", checkToken, fetchOppsLoV);
router.post("/fetchPartyLoV", checkToken, fetchPartyLoV);
router.post("/fetchPartyDetails", checkToken, fetchPartyDetails);
router.post("/generateEstCode", checkToken, generateEstCode);
router.post("/", checkToken, addEstimation);
router.post("/fetchEstSummary", checkToken, fetchAllEstimation);
router.post("/fetchEstById", checkToken, fetchEstById);
router.post("/updateEstimation", checkToken, updateEst);


module.exports = router;