const connectionPool = require("../../config/db");

module.exports={
    fetchEstLoV:(callBack)=>{
connectionPool.query(`SELECT estCode from XXCRM_ESTIMATION_HEADER order by id asc`,[],
(error, results, fields)=>{
    if(error){
        return callBack(error);
    }
    return callBack(null, results);
})
    },
    fetchLeadLoV:(callBack)=>{
        connectionPool.query(`SELECT LeadID as leadId from XXCRM_LEADS order by id asc`,[],
        (error, results, fields) => {
            if(error){
                return callBack(error);
            }
            return callBack(null, results);
        })
    },
    fetchOppsLoV:(callBack)=>{
        connectionPool.query(`SELECT OppID as oppId from XXCRM_OPPS order by id asc`,[],
        (error, results, fields)=>{
            if(error){
                return callBack(error);
            }
            return callBack(null, results);
        })
    },
    fetchPartyLoV:(callBack)=>{
        connectionPool.query(`SELECT id, partyCode, partyName from XXCRM_PARTY order by id asc`,[],
        (error, results, fields)=>{
            if(error){
                return callBack(error);
            }
            return callBack(null, results);
        })
    },
    fetchPartyDetails:(data,callBack)=>{
        connectionPool.query(`SELECT partyCode, partyType from XXCRM_PARTY where id = ? limit 1`,[data.id],
        (error, results, fields)=>{
            if(error){
                return callBack(error);
            }
            return callBack(null, results);
        })
    },
    generateEstCode:(callBack)=>{
        connectionPool.query(`select estCode from XXCRM_ESTIMATION_HEADER order by id desc limit 1`,[],
        (error, results, fields) =>{
           var numRows = results.length;
           
            if(error){
                return callBack(error);
            }

results['numRows']=numRows;
            return callBack(null, results);
        })
    },
    addEstimation:(data, callBack)=>{
        connectionPool.query(`INSERT INTO XXCRM_ESTIMATION_HEADER(oppsId, 
        leadId, estimationDate, partyName, partyCode, partyType, business, 
        offering, type, description, SPOC, preparedBy, approvedBy, currency, 
        effortIn) VALUES (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)`,[data.oppsId, data.leadId, data.estimationDate,
        data.partyName, data.partyCode, data.partyType, data.business,data.offering, data.engagementType,
    data.description, data.spoc, data.preparedBy, data.approvedBy,data.currency, data.effortIn],
        (error, results, fields)=>{
            if(error){
                return callBack(error);
            }
            var lastInsertedId = results.insertId;
            for(const result of data.lineData){

                connectionPool.query(`INSERT INTO XXCRM_ESTIMATION_LINE(estimateId, serialNo, 
                activity, funOrTech, seniorMidJunior, effortId, rate, value) VALUES
                (?,?,?,?,?,?,?,?)`,[lastInsertedId,result.s_no,result.activity,
                result.funcOrTech,result.seniorMidJunior,result.effort,result.rate,result.value ],
                (error, results, fields)=>{
                    if(error){
                        return callBack(error);
                    }

                })
            }
            return callBack(null, results);
        })
    },
    fetchAllEstimation:(data,offset, pagesize,callBack)=>{
var idFilter, oppsFilter, leadsFilter, partyFilter, businessFilter;
        if(data.estCode == ''){
            idFilter = '';
        }
        else{
            idFilter = 'and estCode = ("'+data.estCode+'")';
        }
        if(data.partyCode == ''){
            partyFilter = '';
        }
        else{
            partyFilter = 'and partyCode = ("'+data.partyCode+'")';
        }
        if(data.oppsId == ''){
            oppsFilter = '';
        }
        else{
            oppsFilter = 'and oppsId = ("'+data.oppsId+'")';
        }
        if(data.leadsId == ''){
            leadsFilter = '';
        }
        else{
            leadsFilter = 'and leadId = ("'+data.leadsId+'")';
        }
        if(data.business == ''){
            businessFilter='';
        }
        else{
            businessFilter='and business=("'+data.business+'")';
        }
        connectionPool.query(`SELECT id,estCode, oppsId, leadId, estimationDate, partyName,
         partyCode, partyType, business, offering, type, description, SPOC, 
         preparedBy, approvedBy, currency, effortIn FROM XXCRM_ESTIMATION_HEADER WHERE 1=1 
         ${idFilter} ${oppsFilter} ${leadsFilter} ${partyFilter} ${businessFilter} LIMIT ${offset},${pagesize}`,[],
        (error, results, fields)=>{
            if(error){
                return callBack(error);
            }
            return callBack(null, results);
        })
    },
    fetchEstById:(data, callBack)=>{
        // console.log(data)
        connectionPool.query(`SELECT id,estCode, oppsId, leadId, estimationDate, partyName,
        partyCode, partyType, business, offering, type, description, SPOC, 
        preparedBy, approvedBy, currency, effortIn FROM XXCRM_ESTIMATION_HEADER WHERE id = ?`,[data.id],
        (error, results, fields)=>{
            if(error){
                return callBack(error);
            }
            connectionPool.query(`SELECT id as line_id, estimateId, serialNo, activity, funOrTech,
             seniorMidJunior, effortId, rate, value, createdBy, creationDate,
              updatedBy, updatedDate FROM XXCRM_ESTIMATION_LINE WHERE estimateId = ?`,[data.id],
              (error, lineresults, fields)=>{
                results[0]['lineData'] = lineresults;
                return callBack(null, results);         
             })
        })

    },
    updateEst:(data, callBack)=>{
        connectionPool.query(`UPDATE XXCRM_ESTIMATION_HEADER
        SET oppsId = ?, leadId = ?, estimationDate = ?,
        partyName = ?,partyCode = ?,partyType = ?,
        business = ?, offering = ?,type = ?,description = ?,
        spoc = ?, approvedBy =?,preparedBy=?,currency=?,effortIn=?
        WHERE id = ?`,[data.oppsId, data.leadId, data.estimationDate, data.partyName,
        data.partyCode, data.partyType, data.business, data.offering, data.engagementType,
    data.description, data.spoc,data.approvedBy,data.preparedBy,data.currency,data.effortIn,
data.id],
    (error, results, fields)=>{
        if(error){
            return callBack(error);
        }
        for(const result of data.lineData){

            connectionPool.query(`UPDATE XXCRM_ESTIMATION_LINE
            SET activity = ?,funOrTech = ?,seniorMidJunior=?,effortId=?,
            rate=?,value=? where estimateId =? and id = ?`,
            [result.activity, result.funcOrTech, result.seniorMidJunior,
            result.effortId,result.rate,result.value,data.id,result.line_id],
            (error, results, fields)=>{
                if(error){
                    return callBack(error);
                }
            })
        }
        return callBack(null, results);

    })
    }












}