const connectionPool = require("../../config/db");

module.exports = {
    createParty: (data, callBack)=>{
        connectionPool.query(`INSERT INTO XXCRM_PARTY(partyName, partyCode, partyType, 
        address1, address2, address3, city, state, pincode, country, region, status, 
        website, email, telephone, industry, source, sourceDetails, kaladiBusiness, 
        kaladiBusinessValue1, kaladiBusinessValue2, kaladiSPOCMain, SPOCMainEmail, SPOCMainMobile, 
        kaladiSPOCSecond, SPOCSecondmail, SPOCSecondMobile, kaladiSPOCThird, SPOCThirdmail, 
        SPOCThirdMobile) VALUES
        (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)`,
        [data.partyName, data.partyCode, data.partyType, data.address1,data.address2,data.address3,data.city,data.state,
            data.pincode,data.country,data.region,data.status,data.website,data.email,data.telephone,data.industry,
            data.source,
            data.sourceDetails,data.kaladiBusiness,data.kaladiBusinessValue1,data.kaladiBusinessValue2,
            data.kaladiSPOCMain,data.SPOCMainEmail,data.SPOCMainMobile,data.kaladiSPOCSecond,
            data.SPOCSecondmail,data.SPOCSecondMobile,data.kaladiSPOCThird,data.SPOCThirdmail,
            data.SPOCThirdMobile
        ],(error, results, fields)=>{
            if(error){
                return callBack(error);
            }
            return callBack(null, results);

        })
    },
    fetchAllParties:(data,offset, pagesize, callBack)=>{
var partyIdFilter, partyNameFilter,businessFilter,regionFilter,partyTypeFilter;
// console.log(data.partyId);
        if(data.partyId == ''){
            partyIdFilter = '';
        }
        else{
            partyIdFilter = 'and partyCode = ("'+data.partyId+'")';
        }
        if(data.partyName == ''){
            partyNameFilter = '';
        }
        else{
            partyNameFilter = 'and partyCode = ("'+data.partyId+'")';
        }
        if(data.business == ''){
            businessFilter = '';
        }
        else{
            businessFilter = 'and kaladiBusiness = ("'+data.business+'")';
        }
        if(data.region == ''){
            regionFilter = '';
        }
        else{
            regionFilter = 'and region = ("'+data.region+'")';
        }
        if(data.partyType == ''){
            partyTypeFilter = '';
        }
        else{
            partyTypeFilter = 'and partyType = ("'+data.partyType+'")';
        }
    
        connectionPool.query(`SELECT partyName, partyCode, partyType, address1, address2,
         address3, city, state, pincode, country, region, status, website, email,
          telephone, industry, source, sourceDetails, kaladiBusiness, kaladiBusinessValue1,
           kaladiBusinessValue2, kaladiSPOCMain, SPOCMainEmail, SPOCMainMobile, kaladiSPOCSecond,
            SPOCSecondmail, SPOCSecondMobile, kaladiSPOCThird, SPOCThirdmail, SPOCThirdMobile
             FROM XXCRM_PARTY WHERE 1=1 ${partyIdFilter} ${regionFilter} ${businessFilter} ${partyNameFilter} 
             ${partyTypeFilter} LIMIT ${offset},${pagesize}`,[],
             (error,results,fields)=>{
                 if(error){
                     return callBack(error);
                 }
                 return callBack(null, results);
             })
    },
    fetchPartyById:(data, callBack)=>{
        connectionPool.query(`SELECT partyName, partyCode, partyType, address1, address2,
         address3, city, state, pincode, country, region, status, website, email,
          telephone, industry, source, sourceDetails, kaladiBusiness, kaladiBusinessValue1,
           kaladiBusinessValue2, kaladiSPOCMain, SPOCMainEmail, SPOCMainMobile, kaladiSPOCSecond,
            SPOCSecondmail, SPOCSecondMobile, kaladiSPOCThird, SPOCThirdmail, SPOCThirdMobile
             FROM XXCRM_PARTY WHERE 1=1 and id = ?`,[data.id],
             (error,results,fields)=>{
                 if(error){
                     return callBack(error);
                 }
                 return callBack(null, results);
             })
    },
    updateParty:(data,callBack)=>{
        connectionPool.query(`UPDATE XXCRM_PARTY
                    SET partyName = ?, partyType = ?, address1 = ?, address2 = ?, address3 = ?,
                    city = ?, state = ?, pincode = ?, country = ?, region = ?, status = ?,
                    website = ?, email = ?, telephone = ?, industry = ?, source = ?, sourceDetails = ?,
                    kaladiBusiness = ?, kaladiBusinessValue1 = ?, kaladiBusinessValue2 = ?,kaladiSPOCMain = ?,
                    SPOCMainEmail = ?, SPOCMainMobile = ?, kaladiSPOCSecond = ?, SPOCSecondmail = ?,
                    SPOCSecondMobile = ?, kaladiSPOCThird = ?,SPOCThirdmail = ?, SPOCThirdMobile = ? where
                    id = ?`,[
                        data.partyName, data.partyType, data.address1,data.address2,data.address3,data.city,data.state,
            data.pincode,data.country,data.region,data.status,data.website,data.email,data.telephone,data.industry,
            data.source,
            data.sourceDetails,data.kaladiBusiness,data.kaladiBusinessValue1,data.kaladiBusinessValue2,
            data.kaladiSPOCMain,data.SPOCMainEmail,data.SPOCMainMobile,data.kaladiSPOCSecond,
            data.SPOCSecondmail,data.SPOCSecondMobile,data.kaladiSPOCThird,data.SPOCThirdmail,
            data.SPOCThirdMobile,data.id
                    ],(error, results, fields)=>{
                        if(error){
                            return callBack(error);
                        }
                        return callBack(null, results);  
                    })
    },
    generateCode:(callBack)=>{
        connectionPool.query(`select partyCode from XXCRM_PARTY order by id desc limit 1`,[],
        (error, results, fields) =>{
           var numRows = results.length;
           
            if(error){
                return callBack(error);
            }

results['numRows']=numRows;
            return callBack(null, results);
        })
    }
}