const { employeeLoV,create, 
    getUsers,
     getUsersById,
      updateUser,
      checkUser } = require("./user.services");  // calling service from user.service.js (create)
const { genSaltSync,hashSync,compareSync } = require('bcrypt');
const { sign } = require('jsonwebtoken');
//controller (eg: createUser has 2 parameters)





module.exports = {
    employeeLoV : (req,res) =>{
      
        employeeLoV((err, results) =>{    ///calling create service here with 2 params -> body and callback ,callback has 2 params(err, results)
            if(err){
                console.log(err);
                return res.status(500).json({
                    sucess: 0,
                    message: "Database Connection Error/Query Error"
                }) 
            }
            if(!results){   //if result is empty
return res.json({
    success:0,
    message: "Records Not found"
})
            }
            return res.json({
                success:1,
                data: results
            })
        });

    },
    createUser : (req,res) =>{
        const body = req.body; //to save the data the user sends (better for accessing)
        const salt = genSaltSync(10);
        body.password = hashSync(body.password, salt);
        create(body, (err, results) =>{    ///calling create service here with 2 params -> body and callback ,callback has 2 params(err, results)
if(err){
    console.log(err);
    return res.status(500).json({
        sucess: 0,
        message: "Database Connection Error/Query Error"
    })
}
return res.status(200).json({
    success:1,
    data:results

})
        });

    },
    getAllUsers: (req,res)=>{
        var body = req.body;
        // console.log(body);
        var employeeId = body.employeeId;
        var fromDate = body.fromDate;
        var toDate = body.toDate;
        var businessType = body.BusinessType;
        var status = body.status;
        var role = body.role;
        // var page = body.page;
        var pagenum = body.page;
    var pagesize = 10;
    var offset = (pagenum-1)*pagesize;
        var employeeIdFilter;
        var businessTypeFilter;
        var statusFilter;
        var roleFilter;
        
        if(employeeId == ''){
            employeeIdFilter = '';
        }
        else{
            employeeIdFilter = 'and employeeId = "'+employeeId+'"';
        }
        if(businessType == ''){
            businessTypeFilter = '';
        }
        else{
            businessTypeFilter = 'and BusinessType = "'+businessType+'"';
        }
        if(status == ''){
            statusFilter = '';
        }
        else{
            statusFilter = 'and Status = "'+status+'"';
        }
        if(role == ''){
            roleFilter = '';
        }
        else{
            roleFilter = 'and role = "'+role+'"';
        }
        var dateFilter = 'and dateOfUser between "'+fromDate+'" and "'+toDate+'"';
        
        getUsers(employeeIdFilter, businessTypeFilter, statusFilter, roleFilter, dateFilter,offset,pagesize, (err,results)=>{
            if(err){
                console.log(err);
                return res.status(500).json({
                    sucess: 0,
                    message: "Database Connection Error/Query Error"
                }) 
            }
            if(!results){   //if result is empty
return res.json({
    success:0,
    message: "Records Not found"
})
            }
            return res.json({
                success:1,
                data: results
            })
        })
    },
    getUsersById: (req,res)=>{
        const id = req.params.id;
        getUsersById(id, (err, results)=>{
            if(err){
                console.log(err);
                return res.status(500).json({
                    sucess: 0,
                    message: "Database Connection Error/Query Error"
                }) 
            }
            if(!results){   //if result is empty
return res.json({
    success:0,
    message: "Record Not found with this ID"
})
            }
            return res.json({
                success:1,
                data: results
            })

        })
    },
    updateUser : (req,res) =>{
        const body = req.body; //to save the data the user sends (better for accessing)
        const salt = genSaltSync(10);
        body.password = hashSync(body.password, salt);
        updateUser(body, (err, results) =>{    ///calling create service here with 2 params -> body and callback ,callback has 2 params(err, results)
if(err){
    console.log(err);
    return res.status(500).json({
        sucess: 0,
        message: "Database Connection Error/Query Error"
    })
}
return res.status(200).json({
    success:1,
message: "Updated Successfully"
})
        });

    },
    login: (req,res)=>{
        const body = req.body;
        checkUser(body, (err,results)=>{
            if(err){
                console.log(err);
                return res.status(500).json({
                    sucess: 0,
                    message: "Database Connection Error/Query Error"
                }) 
            }
            if(!results){
                return res.json({
                    success:0,
                    message: "Invalid Email or Password"
                })
            }
            const result = compareSync(body.password , results.password);
            if(result){
                results.password = undefined;
                const jsontoken = sign({ result: results}, "asd1234", {expiresIn:"1h"});
                return res.json({
                    success: 1,
                    data: results,
                    message: "Logged In Successfully",
                    token: jsontoken
                })
            }
            return res.json({
                success:0,
                message:"Invalid Email or Password..."
            });
            
        })
    }


}