const connectionPool = require("../../config/db");

//.query()-> parameters --> query, array of data to be passed, callback functions(error,results,fields)
module.exports = {
    employeeLoV:(callBack)=>{
connectionPool.query(`SELECT employeeId from XXCRM_USERS order by employeeId asc`,[],
(error, results, fields)=>{
    if(error){
        return callBack(error);
    }
    return callBack(null, results);
})
    },
    create : (data, callBack) =>{
        connectionPool.query(`INSERT INTO XXCRM_USERS(firstName, lastName, employeeId, 
        userEmail, password, BusinessType, position, role, Status, dateOfUser) 
        VALUES(?,?,?,?,?,?,?,?,?,?)`,
         [
         data.firstName,
         data.lastName,
         data.employeeId,
         data.userEmail,
         data.password,
         data.businessType,
         data.position,
         data.role,
         data.status,
         data.dateOfUser
         ],
         (error, results, fields) =>{
             if(error){
                 return callBack(error);
             }
             return callBack(null, results);
         });
    },
    getUsers: (idFilter, businessFilter, statusFilter, roleFilter, dateFilter,offset,pagesize, callBack) =>{

        connectionPool.query(`SELECT id, firstName, lastName, employeeId, userEmail, 
        password, BusinessType, position, role, Status, dateOfUser FROM XXCRM_USERS where 1=1 
        ${idFilter} ${businessFilter}  ${statusFilter} ${roleFilter} ${dateFilter} LIMIT ${offset} , ${pagesize}`, [],
        (error, results, fields)=>{
            if(error){
                return callBack(error);
            }
            return callBack(null, results);
        })
    },
    getUsersById: (id, callBack)=>{                                          //no data.id bcoz it comes in query params
        connectionPool.query(`SELECT id, firstName, lastName, employeeId, userEmail, 
        password, BusinessType, position, role, Status, dateOfUser FROM XXCRM_USERS where id = ?`,[id],
        (error, results, fields)=>{
            if(error){
                return callBack(error);
            }
            return callBack(null, results[0]);
        })
    },
    updateUser: (data,callBack)=>{
        connectionPool.query(`Update XXCRM_USERS set firstName= ?, lastName= ?,
        employeeId=?, userEmail=?, password=?,
        BusinessType=?, position=?, role=?,
        Status=?, dateOfUser=? where id = ?`,
        [
            data.firstName,
         data.lastName,
         data.employeeId,
         data.userEmail,
         data.password,
         data.businessType,
         data.position,
         data.role,
         data.status,
         data.dateOfUser,
         data.id

        ], (error, results, fields)=>{
            if(error){
                return callBack(error);
            }
            if(!results){
                return results.json({
                    success:0,
                    message:"Failed to update the user"
                })
            }
            return callBack(null, results);
        })
    },
    checkUser: (data, callBack)=>{
        connectionPool.query(`select firstName, lastName, employeeId, userEmail, password,
         BusinessType, position, role, Status, dateOfUser from XXCRM_USERS where userEmail =?`,
        [data.userEmail], 
        (error, results, fields) =>{
            if(error){
                return callBack(error);
            }
            return callBack(null, results[0]);
        })
    }
};
