require('dotenv').config();
const cors = require('cors');
const express = require('express');
const bodyParser = require('body-parser');
const fs = require('fs');
const mime = require('mime');
const util = require("util");
const multer = require("multer");
const app = express();  //object for express
// console.log(app.connect);

global.__basedir = __dirname;


//Routers
const userRouter = require("./api/user/user.router");
const leadRouter = require("./api/leads/lead.router");
const dashboardRouter = require("./api/dashboard/dashboard.router");
const lovAdminRouter = require("./api/admin/lov/lov.router");
const partyRouter = require("./api/party/party.router");
const contactRouter = require("./api/contact/contact.router");
const estimationRouter = require("./api/estimation/est.router");
const artifactRouter = require("./api/artifacts/artifacts.router");
app.use(cors());

// var corsOptions = {
//     origin: "http://localhost:3000"
//   };
  
//   app.use(cors(corsOptions));
  
// // Add headers before the routes are defined
app.use(function (req, res, next) {

    // Website you wish to allow to connect
    res.setHeader('Access-Control-Allow-Origin', '*');

    // Request methods you wish to allow
    res.setHeader('Access-Control-Allow-Methods', 'GET, POST, OPTIONS, PUT, PATCH, DELETE');

    // Request headers you wish to allow
    res.setHeader('Access-Control-Allow-Headers', 'X-Requested-With,content-type');

    // Set to true if you need the website to include cookies in the requests sent
    // to the API (e.g. in case you use sessions)
    res.setHeader('Access-Control-Allow-Credentials', true);

    // Pass to next layer of middleware
    next();
});

//jsonbody
app.use(express.json());

//executing
app.use("/api/users", userRouter);
app.use("/api/leads", leadRouter);
app.use("/api/dashboard", dashboardRouter);
app.use("/api/admin/lov", lovAdminRouter);
app.use("/api/party", partyRouter);
app.use("/api/contact", contactRouter);
app.use("/api/estimation", estimationRouter);
app.use("/api/artifacts", artifactRouter);

var PORT = 3000;
 
app.listen(PORT, function(err){
    if (err) console.log("Error in server setup")
    console.log("Server listening on Port", PORT);
})



